DEFINT A-Z
'$INCLUDE: 'KVESA.BI'

DIM SHARED regs%(10)
DIM SHARED VESAmode%(256), vesaxdim%(256), numvesas%
DIM SHARED vesaydim%(256), vesabits%(256)
DIM SHARED vesabpl%(256), vesapage%(256)
DIM SHARED vesawingran%, bytesperline&, curnumcols&, ovesapage&
DIM SHARED curmodebits%, curmodedim%, vgacompatible%
DIM SHARED lastrefresh#

FUNCTION VESAcheck

   DIM svgainfo%(128)
   regs%(0) = &H4F00
   regs%(6) = VARPTR(svgainfo%(0))
   regs%(9) = VARSEG(svgainfo%(0))
   svgainfo%(0) = 0 'CVI("VB") 'DO NOT ENABLE VBE2: CAUSES MEMORY CORRUPTION!
   svgainfo%(1) = 0 'CVI("E2")
   CALL int86xold(&H10, regs%(), regs%())
   VESAcheck% = ABS(regs%(0) <> &H4F)
   DEF SEG = svgainfo%(8): P& = svgainfo%(7)
   CLS
   numvesas% = 0
   DO
      mode& = PEEK(P&) + PEEK(P& + 1) * 256&: P& = P& + 2
      IF mode& = 65535 THEN EXIT DO
      VESAmode%(numvesas%) = mode&
      numvesas% = numvesas% + 1
   LOOP
   FOR z% = 0 TO numvesas% - 1
      regs%(0) = &H4F01
      regs%(2) = VESAmode%(z%)
      CALL int86xold(&H10, regs%(), regs%())
      DEF SEG = regs%(9): P& = regs%(6)
      'if (peek(p&) and 32) then vgacompatible%
      IF (PEEK(P&) AND 16) <> 0 THEN
         vesawingran% = PEEK(P& + 4) + 256& * PEEK(P& + 5)
         vesabpl%(z%) = PEEK(P& + 16) + 256& * PEEK(P& + 17)
         vesaxdim%(z%) = PEEK(P& + 18) + 256& * PEEK(P& + 19)
         vesaydim%(z%) = PEEK(P& + 20) + 256& * PEEK(P& + 21)
         vesabits%(z%) = PEEK(P& + 25)
         vesapage%(z%) = PEEK(P& + 29)
      END IF
   NEXT z%

   FOR z% = 1 TO numvesas% - 1
      FOR zz% = 0 TO z% - 1
         IF vesaxdim%(z%) < vesaxdim%(zz%) OR (vesaxdim%(z%) = vesaxdim%(zz%) AND vesaydim%(z%) < vesaydim%(zz%)) OR (vesaxdim%(z%) = vesaxdim%(zz%) AND vesaydim%(z%) = vesaydim%(zz%) AND vesabits%(z%) < vesabits%(zz%)) THEN
            SWAP VESAmode%(z%), VESAmode%(zz%)
            SWAP vesaxdim%(z%), vesaxdim%(zz%)
            SWAP vesaydim%(z%), vesaydim%(zz%)
            SWAP vesabits%(z%), vesabits%(zz%)
            SWAP vesabpl%(z%), vesabpl%(zz%)
            SWAP vesapage%(z%), vesapage%(zz%)
         END IF
      NEXT zz%
   NEXT z%

   curmodebits% = 1: curmodedim% = 0

END FUNCTION

SUB VESAdrawPixelPal (x&, y&, col&)
   DEF SEG = &HA000
   SELECT CASE curnumcols&
      CASE 4:
         P& = y& * bytesperline& + x& \ 8
         OUT &H3CE, &H8: OUT &H3CF, 2 ^ (x& AND 7 XOR 7)    'bit mask
         IF P& \ 65536 <> ovesapage& THEN CALL VESAsetPage(P& \ 65536)
         POKE P& AND 65535, (PEEK(P& AND 65535) AND 0) + (col& AND 15)
      CASE 8:
         P& = y& * bytesperline& + x&
         IF P& \ 65536 <> ovesapage& THEN CALL VESAsetPage(P& \ 65536)
         POKE P& AND 65535, col&
   END SELECT
END SUB

SUB VESAdrawPixelRGB (x&, y&, r&, g&, b&)
   DEF SEG = &HA000
   SELECT CASE curnumcols&
      CASE 15:
         P& = y& * bytesperline& + x& * 2
         IF P& \ 65536 <> ovesapage& THEN CALL VESAsetPage(P& \ 65536)
         P& = P& AND 65535
         v& = (r& \ 8) * 1024 + (g& \ 8) * 32 + (b& \ 8)
         POKE P&, (v& AND 255): POKE P& + 1, (v& \ 256)
      CASE 16:
         P& = y& * bytesperline& + x& * 2
         IF P& \ 65536 <> ovesapage& THEN CALL VESAsetPage(P& \ 65536)
         P& = P& AND 65535
         v& = (r& \ 8) * 2048 + (g& \ 4) * 32 + (b& \ 8)
         POKE P&, (v& AND 255): POKE P& + 1, (v& \ 256)
      CASE 24:
         P& = y& * bytesperline& + x& * 3
         IF P& \ 65536 <> ovesapage& THEN CALL VESAsetPage(P& \ 65536)
         POKE P& AND 65535, b&
         P& = P& + 1: IF (P& AND 65535) = 0 THEN CALL VESAsetPage(P& \ 65536)
         POKE P& AND 65535, g&
         P& = P& + 1: IF (P& AND 65535) = 0 THEN CALL VESAsetPage(P& \ 65536)
         POKE P& AND 65535, r&
      CASE 32:
         P& = y& * bytesperline& + x& * 4
         IF P& \ 65536 <> ovesapage& THEN CALL VESAsetPage(P& \ 65536)
         P& = P& AND 65535
         POKE P& + 2, r&: POKE P& + 1, g&: POKE P& + 0, b&
   END SELECT
END SUB

SUB VESAsetNumBytes (dabytesperline&, xmax&, ymax&)
   regs%(0) = &H4F06            'Vesa set bytes per line
   regs%(1) = 0                 '0 - set, 1 - get
   regs%(2) = dabytesperline&   'width in pixels
   CALL int86xold(&H10, regs%(), regs%())
   IF regs%(0) <> &H4F THEN xmax& = 0: ymax& = 0: EXIT SUB
   bytesperline& = regs%(1)
   xmax& = regs%(2)
   ymax& = regs%(3)
END SUB

SUB VESAsetPage (page&)
   ovesapage& = page&
   regs%(0) = &H4F05
   regs%(1) = &H0
   regs%(3) = (page& * 64) \ vesawingran%
   CALL int86xold(&H10, regs%(), regs%())
END SUB

SUB VESAsetPan (x&, y&)
   regs%(0) = &H4F07
   regs%(1) = 0
   regs%(2) = x&
   regs%(3) = y&
   CALL int86xold(&H10, regs%(), regs%())
END SUB

SUB VESAsetTextMode

regs%(0) = &H4F02
regs%(1) = &H3
CALL int86xold(&H10, regs%(), regs%())

END SUB

FUNCTION VESAsetVideoMode% (daxdim&, daydim&, dabits&)
   FOR z% = numvesas% - 1 TO 0 STEP -1
      IF vesaxdim%(z%) = daxdim& AND vesaydim%(z%) = daydim& AND vesabits%(z%) = dabits& THEN EXIT FOR
   NEXT z%
   IF z% < 0 THEN VESAsetVideoMode% = -1: EXIT FUNCTION
     
   regs%(0) = &H4F01
   regs%(2) = VESAmode%(z%)
   CALL int86xold(&H10, regs%(), regs%())
   DEF SEG = regs%(9): P& = regs%(6)
   IF (PEEK(P&) AND 32) = 0 THEN vgacompatible% = 1 ELSE vgacompatible% = 0

   regs%(0) = &H4F02
   regs%(1) = VESAmode%(z%)
   CALL int86xold(&H10, regs%(), regs%())
   IF regs%(0) <> &H4F THEN IF z% < 0 THEN VESAsetVideoMode% = -2: EXIT FUNCTION
   bytesperline& = vesabpl%(z%)
   curnumcols& = vesabits%(z%)
   ovesapage& = 0
   IF vesabits%(z%) = 4 THEN
      OUT &H3CE, &H0: OUT &H3CF, 15
      OUT &H3CE, &H1: OUT &H3CF, 15
      OUT &H3CE, &H5: OUT &H3CF, (INP(&H3CF) AND (255 - 3)) + 2
   END IF
   VESAsetVideoMode% = 0
   CALL VESAsetPage(0)

END FUNCTION

